# DeTEE Brain

The Brain works similarly to a decentralized oracle that runs on TEEs. It has the capability to scale data distribution by leveraging [DHTs](https://en.wikipedia.org/wiki/Distributed_hash_table), and is tailored to offer a secure and redundant database for the contracts of the DeTEE network. The contracts define the relationship between user and node (resources, price of resources, [SLA](https://en.wikipedia.org/wiki/Service-level_agreement)).

Similar to the hacker challenge, the brain will create smart contracts on various blockchains, which will allow users to deposit tokens into the DeTEE network, and withdraw tokens from the network. The tokens that are in the network can be used for:
- consuming resources on the network (VMs or containers)
- voting for the upgrades of the brain
  - voting power is based on the amount of resources consumed in the last cycle
  - the customer is always right, so the customer gets to choose the software
- providing escrow as a node operator or as a user
  - escrow can be used to compensate for low rating, based on the free market principle
- delegating escrow to servers and to users in order to get rewards

This component is currently under development. The high level mechanics of the brain are simulated in a centralized API, that will be used to power the testnet till the release of the decentralized brain.

<script type="text/javascript" id="hcb" src="/js/comments.js"></script><div id="HCB_comment_box"></div><link rel="stylesheet" type="text/css" href="/css/comments.css"/>
